// ConnectDialog.java
import java.awt.*;
import java.awt.event.*;

/**
 *  Class ConnectDialog2.java
 *  @author: Anders Sandstrom
 *  UCCS 1997
 */
public class ConnectDialog2 extends Dialog implements ActionListener{

    //{{DECLARE_CONTROLS
    TextField nameField;
    TextField conferenceNameField;
    TextField serverPortField;
    TextField serverIpField;
    TextField messageField;

    private Label nameLabel;
    private Label serverPortLabel;
    private Label serverIpLabel;
    private Label conferenceNameLabel;

    private Label messageLabel;
    private Button connectButton;
    private Button cancelButton;

    private ConnectInfo connectInfo;

    private ResultProcessor owner;


    boolean debug=false;
    //}}

    /**
     *  Constructor ConnectDialog2:
     */
    public ConnectDialog2(Frame frame, ResultProcessor owner,String heading,boolean modal,ConnectInfo cInfo) {

      super(frame,heading, modal);
      connectInfo=cInfo;
	    setup();
      pack();
      setResizable(false);
      this.owner=owner;
      init();
    }

	/**
	 *  Method setup():
	 *  The code in this method sets up the Dialog user interface
	 *  and is generated by Symantic Cafe's resource editor.
	 *
	 *  Future development:
	 *  The layout should be convereted to Gridbaglayout to ensure
	 *  portability.
	 */
	void setup(){

        setLayout(null);
        addNotify();
        setSize(getInsets().left + getInsets().right + 403, getInsets().top + getInsets().bottom + 292);

        nameField=new TextField(connectInfo.userName,19);
        add(nameField);
        nameField.setBounds(getInsets().left + 176,getInsets().top + 40,198,24);

        serverIpField=new TextField(connectInfo.serverIp,19);
        add(serverIpField);
        serverIpField.setBounds(getInsets().left + 176,getInsets().top + 72,198,24);

        serverPortField=new TextField(connectInfo.serverPort,19);
        add(serverPortField);
        serverPortField.setBounds(getInsets().left + 176,getInsets().top + 104,198,24);

        conferenceNameField=new TextField(connectInfo.conferenceName,19);
        add(conferenceNameField);
        conferenceNameField.setBounds(getInsets().left + 176,getInsets().top + 136,198,24);

        nameLabel=new Label("Name");
        add(nameLabel);
        nameLabel.setBounds(getInsets().left + 23,getInsets().top + 48,139,16);

        serverIpLabel=new Label("Server IP");
        add(serverIpLabel);
        serverIpLabel.setBounds(getInsets().left + 23,getInsets().top + 80,139,16);

        serverPortLabel=new Label("Server Port");
        add(serverPortLabel);
        serverPortLabel.setBounds(getInsets().left + 23,getInsets().top + 112,139,16);


        conferenceNameLabel=new Label("Conference Name");
        add(conferenceNameLabel);
        conferenceNameLabel.setBounds(getInsets().left + 23,getInsets().top + 144,139,16);

        connectButton=new Button("Connect");
        connectButton.addActionListener(this);
        add(connectButton);
        connectButton.setBounds(getInsets().left + 36,getInsets().top + 184,117,32);

        cancelButton=new Button("Cancel");
        cancelButton.addActionListener(this);
        add(cancelButton);
        cancelButton.setBounds(getInsets().left + 257,getInsets().top + 184,117,32);
    }

    /**
     *  Method init():
     *  Initialization of connectDialog2.
     */
    void init(){
        if(debug)System.out.println("=========================================");
        if(debug) System.out.println("Initialization of ConnectToDialog2.");
        nameField.requestFocus();
        nameField.selectAll();
        if(debug) System.out.println("nameField: "+nameField.toString());
        if(debug) System.out.println("End of ConnectToDialog2 init.");
        if(debug)System.out.println("=========================================");
    }

    /**
     *  Method setVisible(true):
     *  This method puts the dialog box centered on top of parent.
     */
    public synchronized void setVisible(boolean b) {
    	Rectangle parentBounds = getParent().getBounds();
    	Rectangle abounds = getBounds();

    	setLocation(parentBounds.x + (parentBounds.width - abounds.width)/ 2,
    	     parentBounds.y + (parentBounds.height - abounds.height)/2);

    	super.setVisible(b);
    }

    /**
     *  Method wakeup():
     */
    public synchronized void wakeUp() {
    	notify();
    }

    /**
     *  Method hadleEvent():
     */
    public void actionPerformed(ActionEvent event){
      Object source=event.getSource();
      //System.out.println("dialog: "+source.toString());
      if(source==connectButton){
        //System.out.println("source==connectButton");
        clickedConnectButton();
      }
      if(source==cancelButton){
        //System.out.println("source==cancelButton");
        clickedCancelButton();
      }

    }

    public void clickedConnectButton() {
        dispose();
        owner.processResult(this,new ConnectInfo(nameField.getText(),serverIpField.getText(),
                            serverPortField.getText(),conferenceNameField.getText()));
    }
    public void clickedCancelButton() {
        dispose();
    }


}// End of ConnectDialog2 class


