/**
 *  Class DefaultSettings.java
 *  @author: Anders Sandstrom
 *  UCCS 1997
 */
import java.awt.*;

public class DefaultSettings{
  private int defaultFontName;
  private int defaultFontStyle;
  private int defaultFontSize;
  private String defaultFontStyles[]={"Plain","Bold","Italic"};
  private int defaultFontSizes[]={10,12,14,18,24,36,72,86};// add for more sizes
  private int defaultLineWidths[]={1,2,3,4,5,6,8};// add for more sizes

  private int defaultLineWidth;

  private Color defaultForegroundColor;
  private Color defaultBackgroundColor;

  private int defaultWindowWidth=650;
  private int defaultWindowHeight=500;

  private int defaultMode=GraphicalObject.LINE;

  public String about="Zodega1.1 a Masters Project by Anders Sandstrom, 1997. Department of Computer Science, University of Colorado at Colorado Springs.";

  /**
   *  Constructor.
   */
  public DefaultSettings(){
    setupFonts();
    setupColors();
    defaultLineWidth=8;//defaultLineWidths[3];// width=4ppt.
  }

  /**
   *  Setup Fonts.
   */
  void setupFonts(){
    defaultFontStyle=0;// Plain=0, Bold=1, Italic=2;
    defaultFontSize=defaultFontSizes[5];// size=36
    defaultFontName=0; // First Font in list
  }

  /**
   *  Setup Colors.
   *
   */
  void setupColors(){
    defaultBackgroundColor=Color.white;
    defaultForegroundColor=Color.black;
  }

  public Font getFont(){
    return new Font("data",defaultFontStyle,defaultFontSize);
  }

  public String getFontName(String[] names){
    return names[defaultFontName].toString();
  }

  public String[] getFontSizes(){
    String sizes[]=new String[defaultFontSizes.length];
    String temp="";
    for(int i=0;i<defaultFontSizes.length;i++){
      sizes[i]=temp.valueOf(defaultFontSizes[i]);
    }
    return sizes;
  }

  public String[] getFontStyles(){
    return defaultFontStyles;
  }

  public String[] getLineWidths(){
    String widths[]=new String[defaultLineWidths.length];
    String temp="";
    for(int i=0;i<defaultLineWidths.length;i++){
      widths[i]=temp.valueOf(defaultLineWidths[i]);
    }
    return widths;
  }

  public int getLineWidth(){
    return defaultLineWidth;
  }

  public int translateLineWidth(int index){
    return defaultLineWidths[index];
  }

  public int getFontSize(){
    return defaultFontSize;
  }

  public int getFontStyle(){
    return defaultFontStyle;
  }

  /*public int translateFontSize(int index){
    return defaultFontSizes[index];
  }*/

  public int translateFontSize(String string){
    String temp="";
    int size=0;
    for(int i=0;i<defaultFontSizes.length;i++){
      if(string.equals(temp.valueOf(defaultFontSizes[i]))) size=defaultFontSizes[i];
      //System.out.println("dFS="+defaultFontSizes[i]+"\nsize="+size);
    }
    return size;
  }


  public Color getBackgroundColor(){
    return defaultBackgroundColor;
  }

  public Color getForegroundColor(){
    return defaultForegroundColor;
  }

  public int getWindowWidth(){
    return defaultWindowWidth;
  }

  public int getWindowHeight(){
    return defaultWindowHeight;
  }

  public int getMode(){
    return defaultMode;
  }

}