/**
 *  Class GraphicalObject.java
 *  @author: Anders Sandstrom
 *  UCCS 1997
 */

import java.awt.*;
import java.lang.Math;
import java.util.*;
import java.io.*;
//import java.util.Vector;

public class GraphicalObject{
  // Variable Declarations
  public static int LINE=0;
  public static int OVAL=1;
  public static int FILLED_OVAL=2;
  public static int RECTANGLE=3;
  public static int FILLED_RECTANGLE=4;
  public static int FREEHAND=5;
  public static int TEXT=6;
  public static int SELECT=7;
  int type, startX, startY, endX, endY, objectId=0,objectCharId=0, fill=0, objectLineWidth=1, index=0;
  Color objectColor=Color.black;

  public int farg;
  char character;
  boolean debug=false;
  boolean local=false;
//  private DefaultSettings defaultSettings;
  Font objectFont=new Font("Helvetica",0,10);


  // Method Declarations

  public void print(){
    System.out.println("type: "+type);
    System.out.println("startX: "+startX);
    System.out.println("startY: "+startY);
    System.out.println("endX: "+endX);
    System.out.println("endY: "+endY);
    System.out.println("objectId: "+objectId);
    System.out.println("objectCharId: "+objectCharId);
    System.out.println("fill: "+fill);
    System.out.println("objectLineWidth: "+objectLineWidth);
    System.out.println("index: "+index);
    System.out.println("character: "+character);
    System.out.println("objectFont: "+objectFont.toString());
    System.out.println("objectColor: "+objectColor.toString());
    System.out.println("\n");
  }

  public void writeData(PrintWriter os) throws IOException{
    os.print(type);
    os.print("|");
    os.print(startX);
    os.print("|");
    os.print(startY);
    os.print("|");
    os.print(endX);
    os.print("|");
    os.print(endY);
    os.print("|");
    os.print(objectId);
    os.print("|");
    os.print(objectCharId);
    os.print("|");
    os.print(fill);
    os.print("|");
    os.print(objectLineWidth);
    os.print("|");
    os.print(index);
    os.print("|");
    os.print((int)character);
    os.print("|");
    os.print(objectFont.getName());
    os.print("|");
    os.print(objectFont.getStyle());
    os.print("|");
    os.print(objectFont.getSize());
    os.print("|");
    os.print(objectColor.getRGB());
    os.println();
  }

  public void readData(DataInput is) throws IOException{
    String s=is.readLine();
    StringTokenizer t=new StringTokenizer(s,"|");
    type=(new Integer(t.nextToken())).intValue();
    startX=(new Integer(t.nextToken())).intValue();
    startY=(new Integer(t.nextToken())).intValue();
    endX=(new Integer(t.nextToken())).intValue();
    endY=(new Integer(t.nextToken())).intValue();
    objectId=(new Integer(t.nextToken())).intValue();
    objectCharId=(new Integer(t.nextToken())).intValue();
    fill=(new Integer(t.nextToken())).intValue();
    objectLineWidth=(new Integer(t.nextToken())).intValue();
    index=(new Integer(t.nextToken())).intValue();
    int c=(new Integer(t.nextToken())).intValue();
    String fontName=t.nextToken();
    int fontStyle=(new Integer(t.nextToken())).intValue();
    int fontSize=(new Integer(t.nextToken())).intValue();
    int rgb=(new Integer(t.nextToken())).intValue();

    character=(char)c;
    objectColor=new Color(rgb);
    objectFont=new Font(fontName,fontStyle,fontSize);
  }





  // Constructor GraphicalObject()
  public GraphicalObject(int objectType,int i,int x1,int y1,int x2,int y2,int f){
    type =objectType;
    //objectId=id;
    startX=x1;
    startY=y1;
    endX=x2;
    endY=y2;
    fill=f;

  }

  // Constructor GraphicalObject()
  public GraphicalObject(int objectType,int x1,int y1,int x2,int y2){
    type =objectType;
    //objectId=id;
    startX=x1;
    startY=y1;
    endX=x2;
    endY=y2;

  }

  // Constructor GraphicalObject()
  public GraphicalObject(int objectType,int x, int y){
    this(objectType,x,y,x,y);
    //System.out.println("objectType: "+objectType);
    //objectId=id;

  }

  // Constructor GraphicalObject()
  public GraphicalObject(){
    this(LINE,0,0,0,0);
    //objectId=id;

  }

  //method getType()
  public int getType(){
    return type;
  }

  // Method setColor()
  public void setColor(Color color){
    objectColor=color;
  }


  // Method getColor()
  public Color getColor(){
    return objectColor;
  }

  // Method setId()
  public void setId(int id ){
    objectId=id;
  }

  // Method getId()
  public int getId(){
    return objectId;
  }

  // Method setCharId()
  public void setCharId(int id ){
    objectCharId=id;
  }

  // Method getCharId()
  public int getCharId(){
    return objectCharId;
  }

  // Method setLineWidth()
  public void setLineWidth(int width){
    objectLineWidth=width;
  }

  // Method getLineWidth
  public int getLineWidth(){
    return objectLineWidth;
  }

  // Method setChar()
  public void setChar(int key){

    character=(char)key;
  }

  // Method getChar()
  public char getChar(){
    return character;
  }

  // Method setFont()
  public void setFont(Font font){
    objectFont=font;
  }

  // Method setStartX()
  public void setStartX(int x){
    startX=x;
  }

  // Method setStartY()
  public void setStartY(int y){
    startY=y;
  }

  // Method setEndX()
  public void setEndX(int x){
    endX=x;
  }

  // Method setEndY()
  public void setEndY(int y){
    endY=y;
  }

  // Method setIndex()
  public void setIndex(int i){
    index=i;
  }


  // Method setLocal()
  public void setLocal(){
    local=true;
  }

  // Method isLocal()
  public boolean isLocal(){
    return local;
  }

  // Method delete()
  public boolean delete(int id){
    return true;
    }





  // Method draw()
  public void draw(Graphics g){
    g.setColor(objectColor);
      if(type==TEXT){

        char[] chars=new char[1];
        chars[0]=character;
        g.setFont(objectFont);
        g.drawChars(chars,0,1,startX,startY);
      }

      else if(type==LINE){
        if(objectLineWidth==1)
            g.drawLine(startX,startY,endX,endY);
        else{
            float t=0,x=0,y=0,x1,x2,y1,y2,increment,lineLength;
            x1=(float)startX;
            x2=(float)endX;
            y1=(float)startY;
            y2=(float)endY;
            lineLength=(float)Math.sqrt((double)((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)));
            increment=objectLineWidth/(lineLength*2);
            for(t=0;t<1;t+=increment){
                x=Math.round(x1+(x2-x1)*t);
                y=Math.round(y1+(y2-y1)*t);
                g.fillRect((int)x,(int)y,objectLineWidth,objectLineWidth);
            }
        }
      }
      else{
        int w=Math.abs(endX-startX);
        int l=Math.abs(endY-startY);
        if(type==OVAL){
            for(int i=0;i<objectLineWidth;++i) g.drawOval(startX+i,startY+i,w-i*2,l-i*2);
        }
        else if(type==FILLED_OVAL) g.fillOval(startX,startY,w,l);
        else if(type==FILLED_RECTANGLE) g.fillRect(startX,startY,w,l);

        else if(type==RECTANGLE){
            for(int i=0;i<objectLineWidth;++i) g.drawRect(startX+i,startY+i,w-i*2,l-i*2);
        }
        // rewrite this if statement
        else if(type==FREEHAND)
            if(objectLineWidth==1) g.drawLine(startX,startY,startX,startY);
            else g.fillRect(startX,startY,objectLineWidth,objectLineWidth);
      }
  }
}// End of GraphicalObject class
